Whamcloud - gitweb
LU-2020 sanity: test 140 should allow 40 consecutive symlink
[fs/lustre-release.git] / lustre / tests / sanity.sh
index 258f439..4675399 100644 (file)
@@ -1,6 +1,4 @@
 #!/bin/bash
-# -*- mode: Bash; tab-width: 4; indent-tabs-mode: t; -*-
-# vim:autoindent:shiftwidth=4:tabstop=4:
 #
 # Run select tests by setting ONLY, or as arguments to the script.
 # Skip specific tests by setting EXCEPT.
@@ -13,17 +11,16 @@ ONLY=${ONLY:-"$*"}
 ALWAYS_EXCEPT="                27u   42a  42b  42c  42d  45   51d   68b   $SANITY_EXCEPT"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
+# with LOD/OSP landing
+# bug number for skipped tests: LU-2036
+ALWAYS_EXCEPT="                 76     $ALWAYS_EXCEPT"
+
+
 # Tests that fail on uml
 CPU=`awk '/model/ {print $4}' /proc/cpuinfo`
 #                                    buffer i/o errs             sock spc runas
 [ "$CPU" = "UML" ] && EXCEPT="$EXCEPT 27m 27n 27o 27p 27q 27r 31d 54a  64b 99a 99b 99c 99d 99e 99f 101a"
 
-case `uname -r` in
-2.4*) FSTYPE=${FSTYPE:-ext3} ;;
-2.6*) FSTYPE=${FSTYPE:-ldiskfs} ;;
-*) error "unsupported kernel" ;;
-esac
-
 SRCDIR=$(cd $(dirname $0); echo $PWD)
 export PATH=$PATH:/sbin
 
@@ -38,6 +35,7 @@ LCTL=${LCTL:-lctl}
 MCREATE=${MCREATE:-mcreate}
 OPENFILE=${OPENFILE:-openfile}
 OPENUNLINK=${OPENUNLINK:-openunlink}
+export MULTIOP=${MULTIOP:-multiop}
 READS=${READS:-"reads"}
 MUNLINK=${MUNLINK:-munlink}
 SOCKETSERVER=${SOCKETSERVER:-socketserver}
@@ -454,13 +452,29 @@ test_17f() {
 }
 run_test 17f "symlinks: long and very long symlink name ========================"
 
+# str_repeat(S, N) generate a string that is string S repeated N times
+str_repeat() {
+       local s=$1
+       local n=$2
+       local ret=''
+       while [ $((n -= 1)) -ge 0 ]; do
+               ret=$ret$s
+       done
+       echo $ret
+}
+
+# Long symlinks and LU-2241
 test_17g() {
-        mkdir -p $DIR/$tdir
-        LONGSYMLINK="$(dd if=/dev/zero bs=4095 count=1 | tr '\0' 'x')"
-        ln -s $LONGSYMLINK $DIR/$tdir/$tfile
-        ls -l $DIR/$tdir
+       mkdir -p $DIR/$tdir
+       local TESTS="59 60 61 4094 4095"
+
+       for i in $TESTS; do
+               local SYMNAME=$(str_repeat 'x' $i)
+               ln -s $SYMNAME $DIR/$tdir/f$i || error "failed $i-char symlink"
+               readlink $DIR/$tdir/f$i || error "failed $i-char readlink"
+       done
 }
-run_test 17g "symlinks: really long symlink name ==============================="
+run_test 17g "symlinks: really long symlink name and inode boundaries"
 
 test_17h() { #bug 17378
         remote_mds_nodsh && skip "remote MDS with nodsh" && return
@@ -495,6 +509,66 @@ test_17k() { #bug 22301
 }
 run_test 17k "symlinks: rsync with xattrs enabled ========================="
 
+# LU-1540
+test_17m() {
+       local short_sym="0123456789"
+       local WDIR=$DIR/${tdir}m
+       local mds_index
+       local devname
+       local cmd
+       local i
+       local rc=0
+
+       [ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.2.0) ] &&
+       [ $(lustre_version_code $SINGLEMDS) -le $(version_code 2.2.93) ] &&
+               skip "MDS 2.2.0-2.2.93 do not NUL-terminate symlinks" && return
+
+       [ "$(facet_fstype $SINGLEMDS)" != "ldiskfs" ] &&
+               skip "only for ldiskfs MDT" && return 0
+
+       mkdir -p $WDIR
+       long_sym=$short_sym
+       # create a long symlink file
+       for ((i = 0; i < 4; ++i)); do
+               long_sym=${long_sym}${long_sym}
+       done
+
+       echo "create 512 short and long symlink files under $WDIR"
+       for ((i = 0; i < 256; ++i)); do
+               ln -sf ${long_sym}"a5a5" $WDIR/long-$i
+               ln -sf ${short_sym}"a5a5" $WDIR/short-$i
+       done
+
+       echo "erase them"
+       rm -f $WDIR/*
+       sync
+       sleep 2
+
+       echo "recreate the 512 symlink files with a shorter string"
+       for ((i = 0; i < 512; ++i)); do
+               # rewrite the symlink file with a shorter string
+               ln -sf ${long_sym} $WDIR/long-$i
+               ln -sf ${short_sym} $WDIR/short-$i
+       done
+
+       mds_index=$($LFS getstripe -M $WDIR)
+       mds_index=$((mds_index+1))
+       devname=$(mdsdevname $mds_index)
+       cmd="$E2FSCK -fnvd $devname"
+
+       echo "stop and checking mds${mds_index}: $cmd"
+       # e2fsck should not return error
+       stop mds${mds_index} -f
+       do_facet mds${mds_index} $cmd || rc=$?
+
+       start mds${mds_index} $devname $MDS_MOUNT_OPTS
+       df $MOUNT > /dev/null 2>&1
+       [ $rc -ne 0 ] && error "e2fsck should not report error upon "\
+               "short/long symlink MDT: rc=$rc"
+       return $rc
+}
+run_test 17m "run e2fsck against MDT which contains short/long symlink"
+
 test_18() {
        touch $DIR/f
        ls $DIR || error
@@ -693,13 +767,13 @@ run_test 24k "touch .../R11a/f; mv .../R11a/f .../R11a/d ======="
 # bug 2429 - rename foo foo foo creates invalid file
 test_24l() {
        f="$DIR/f24l"
-       multiop $f OcNs || error
+       $MULTIOP $f OcNs || error
 }
 run_test 24l "Renaming a file to itself ========================"
 
 test_24m() {
        f="$DIR/f24m"
-       multiop $f OcLN ${f}2 ${f}2 || error "link ${f}2 ${f}2 failed"
+       $MULTIOP $f OcLN ${f}2 ${f}2 || error "link ${f}2 ${f}2 failed"
        # on ext3 this does not remove either the source or target files
        # though the "expected" operation would be to remove the source
        $CHECKSTAT -t file ${f} || error "${f} missing"
@@ -776,7 +850,7 @@ test_24t() {
 run_test 24t "mkdir .../R16a/b/c; rename .../R16a/b/c .../R16a ="
 
 test_24u() { # bug12192
-        multiop $DIR/$tfile C2w$((2048 * 1024))c || error
+        $MULTIOP $DIR/$tfile C2w$((2048 * 1024))c || error
         $CHECKSTAT -s $((2048 * 1024)) $DIR/$tfile || error "wrong file size"
 }
 run_test 24u "create stripe file"
@@ -1036,6 +1110,7 @@ reset_enospc() {
        [ "$OSTIDX" ] && list=$(facet_host ost$((OSTIDX + 1)))
 
        do_nodes $list lctl set_param fail_loc=0
+       sync    # initiate all OST_DESTROYs from MDS to OST
        sleep_maxage
 }
 
@@ -1358,9 +1433,6 @@ check_seq_oid()
         # compare lmm_object_id and lu_fid->oid
         [ $lmm_oid = ${fid[2]} ] || { error "OID mismatch"; return 2; }
 
-        [ "$FSTYPE" != "ldiskfs" ] &&
-                skip "cannot check filter fid FSTYPE=$FSTYPE" && return 0
-
         # check the trusted.fid attribute of the OST objects of the file
         local have_obdidx=false
         local stripe_nr=0
@@ -1373,6 +1445,11 @@ check_seq_oid()
                 local ost=$((obdidx + 1))
                 local dev=$(ostdevname $ost)
 
+               if [ $(facet_fstype ost$ost) != ldiskfs ]; then
+                       echo "Currently only works with ldiskfs-based OSTs"
+                       continue
+               fi
+
                 log "want: stripe:$stripe_nr ost:$obdidx oid:$oid/$hex seq:$seq"
 
                 #don't unmount/remount the OSTs if we don't need to do that
@@ -1545,7 +1622,7 @@ run_test 31a "open-unlink file =================================="
 test_31b() {
        touch $DIR/f31 || error
        ln $DIR/f31 $DIR/f31b || error
-       multiop $DIR/f31b Ouc || error
+       $MULTIOP $DIR/f31b Ouc || error
        $CHECKSTAT -t file $DIR/f31 || error
 }
 run_test 31b "unlink file with multiple links while open ======="
@@ -1555,7 +1632,7 @@ test_31c() {
        ln $DIR/f31 $DIR/f31c || error
        multiop_bg_pause $DIR/f31 O_uc || return 1
        MULTIPID=$!
-       multiop $DIR/f31c Ouc
+       $MULTIOP $DIR/f31c Ouc
        kill -USR1 $MULTIPID
        wait $MULTIPID
 }
@@ -2066,7 +2143,7 @@ test_34h() {
        local sz=1000
 
        dd if=/dev/zero of=$DIR/$tfile bs=1M count=10 || error
-       multiop $DIR/$tfile OG${gid}T${sz}g${gid}c &
+       $MULTIOP $DIR/$tfile OG${gid}T${sz}g${gid}c &
        MULTIPID=$!
        sleep 2
 
@@ -2427,10 +2504,14 @@ test_39i() {
 run_test 39i "write, rename, stat =============================="
 
 test_39j() {
+       start_full_debug_logging
        touch $DIR1/$tfile
        sleep 1
 
-       multiop_bg_pause $DIR1/$tfile oO_RDWR:w2097152_c || error "multiop failed"
+       #define OBD_FAIL_OSC_DELAY_SETTIME       0x412
+       lctl set_param fail_loc=0x80000412
+       multiop_bg_pause $DIR1/$tfile oO_RDWR:w2097152_c ||
+               error "multiop failed"
        local multipid=$!
        local mtime1=`stat -c %Y $DIR1/$tfile`
 
@@ -2441,12 +2522,15 @@ test_39j() {
 
        for (( i=0; i < 2; i++ )) ; do
                local mtime2=`stat -c %Y $DIR1/$tfile-1`
-               [ "$mtime1" = "$mtime2" ] || \
-                       error "mtime is lost on close: $mtime2, should be $mtime1"
+               [ "$mtime1" = "$mtime2" ] ||
+                       error "mtime is lost on close: $mtime2, " \
+                             "should be $mtime1"
 
                cancel_lru_locks osc
                if [ $i = 0 ] ; then echo "repeat after cancel_lru_locks"; fi
        done
+       lctl set_param fail_loc=0
+       stop_full_debug_logging
 }
 run_test 39j "write, rename, close, stat ======================="
 
@@ -2478,7 +2562,23 @@ run_test 39k "write, utime, close, stat ========================"
 # this should be set to future
 TEST_39_ATIME=`date -d "1 year" +%s`
 
+is_sles11()                                            # LU-1783
+{
+       if [ -r /etc/SuSE-release ]
+       then
+               local vers=`grep VERSION /etc/SuSE-release | awk '{print $3}'`
+               local patchlev=`grep PATCHLEVEL /etc/SuSE-release \
+                       | awk '{print $3}'`
+               if [ $vers -eq 11 ] && [ $patchlev -eq 1 ]
+               then
+                       return 0
+               fi
+       fi
+       return 1
+}
+
 test_39l() {
+       is_sles11 && skip "SLES 11 SP1" && return       # LU-1783
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
        local atime_diff=$(do_facet $SINGLEMDS lctl get_param -n mdd.*.atime_diff)
 
@@ -2781,7 +2881,7 @@ run_test 42e "verify sub-RPC writes are not done synchronously"
 test_43() {
        mkdir -p $DIR/$tdir
        cp -p /bin/ls $DIR/$tdir/$tfile
-       multiop $DIR/$tdir/$tfile Ow_c &
+       $MULTIOP $DIR/$tdir/$tfile Ow_c &
        pid=$!
        # give multiop a chance to open
        sleep 1
@@ -2793,10 +2893,10 @@ run_test 43 "execution of file opened for write should return -ETXTBSY"
 
 test_43a() {
         mkdir -p $DIR/d43
-       cp -p `which multiop` $DIR/d43/multiop || cp -p multiop $DIR/d43/multiop
+       cp -p `which $MULTIOP` $DIR/d43/multiop || cp -p multiop $DIR/d43/multiop
         MULTIOP_PROG=$DIR/d43/multiop multiop_bg_pause $TMP/test43.junk O_c || return 1
         MULTIOP_PID=$!
-        multiop $DIR/d43/multiop Oc && error "expected error, got success"
+        $MULTIOP $DIR/d43/multiop Oc && error "expected error, got success"
         kill -USR1 $MULTIOP_PID || return 2
         wait $MULTIOP_PID || return 3
         rm $TMP/test43.junk
@@ -2805,7 +2905,7 @@ run_test 43a "open(RDWR) of file being executed should return -ETXTBSY"
 
 test_43b() {
         mkdir -p $DIR/d43
-       cp -p `which multiop` $DIR/d43/multiop || cp -p multiop $DIR/d43/multiop
+       cp -p `which $MULTIOP` $DIR/d43/multiop || cp -p multiop $DIR/d43/multiop
         MULTIOP_PROG=$DIR/d43/multiop multiop_bg_pause $TMP/test43.junk O_c || return 1
         MULTIOP_PID=$!
         $TRUNCATE $DIR/d43/multiop 0 && error "expected error, got success"
@@ -3030,6 +3130,30 @@ test_48e() { # bug 4134
 }
 run_test 48e "Access to recreated parent subdir (should return errors)"
 
+test_49() { # LU-1030
+       # get ost1 size - lustre-OST0000
+       ost1_size=$(do_facet ost1 lfs df |grep ${ost1_svc} |awk '{print $4}')
+       # write 800M at maximum
+       [ $ost1_size -gt 819200 ] && ost1_size=819200
+
+       lfs setstripe -c 1 -i 0 $DIR/$tfile
+       dd if=/dev/zero of=$DIR/$tfile bs=4k count=$((ost1_size >> 2)) &
+       local dd_pid=$!
+
+       # change max_pages_per_rpc while writing the file
+       local osc1_mppc=osc.$(get_osc_import_name client ost1).max_pages_per_rpc
+       local orig_mppc=`$LCTL get_param -n $osc1_mppc`
+       # loop until dd process exits
+       while ps ax -opid | grep -wq $dd_pid; do
+               $LCTL set_param $osc1_mppc=$((RANDOM % 256 + 1))
+               sleep $((RANDOM % 5 + 1))
+       done
+       # restore original max_pages_per_rpc
+       $LCTL set_param $osc1_mppc=$orig_mppc
+       rm $DIR/$tfile || error "rm $DIR/$tfile failed"
+}
+run_test 49 "Change max_pages_per_rpc won't break osc extent"
+
 test_50() {
        # bug 1485
        mkdir $DIR/d50
@@ -3058,43 +3182,72 @@ run_test 51a "special situations: split htree with empty entry =="
 
 export NUMTEST=70000
 test_51b() {
-       NUMFREE=`df -i -P $DIR | tail -n 1 | awk '{ print $4 }'`
-       [ $NUMFREE -lt 21000 ] && \
-               skip "not enough free inodes ($NUMFREE)" && \
+       local BASE=$DIR/$tdir
+       mkdir -p $BASE
+
+       local mdtidx=$(printf "%04x" $($LFS getstripe -M $BASE))
+       local numfree=$(lctl get_param -n mdc.$FSNAME-MDT$mdtidx*.filesfree)
+       [ $numfree -lt 21000 ] && skip "not enough free inodes ($numfree)" &&
                return
 
-       [ $NUMFREE -lt $NUMTEST ] && NUMTEST=$(($NUMFREE - 50))
+       [ $numfree -lt $NUMTEST ] && NUMTEST=$(($numfree - 50)) &&
+               echo "reduced count to $NUMTEST due to inodes"
 
-       mkdir -p $DIR/d51b
-       createmany -d $DIR/d51b/t- $NUMTEST
+       # need to check free space for the directories as well
+       local blkfree=$(lctl get_param -n mdc.$FSNAME-MDT$mdtidx*.kbytesavail)
+       numfree=$((blkfree / 4))
+       [ $numfree -lt $NUMTEST ] && NUMTEST=$(($numfree - 50)) &&
+               echo "reduced count to $NUMTEST due to blocks"
+
+       createmany -d $BASE/d $NUMTEST && echo $NUMTEST > $BASE/fnum ||
+               echo "failed" > $BASE/fnum
 }
-run_test 51b "mkdir .../t-0 --- .../t-$NUMTEST ===================="
+run_test 51b "exceed 64k subdirectory nlink limit"
 
 test_51ba() { # LU-993
-        local BASE=$DIR/d51b
-        # unlink all but 100 subdirectories, then check it still works
-        local LEFT=100
-        local DELETE=$((NUMTEST - LEFT))
-
-        ! [ -d "${BASE}/t-$DELETE" ] && skip "test_51b() not run" && return 0
+       local BASE=$DIR/$tdir
+       # unlink all but 100 subdirectories, then check it still works
+       local LEFT=100
+       [ -f $BASE/fnum ] && local NUMPREV=$(cat $BASE/fnum) && rm $BASE/fnum
+
+       [ "$NUMPREV" != "failed" ] && NUMTEST=$NUMPREV
+       local DELETE=$((NUMTEST - LEFT))
+
+       # continue on to run this test even if 51b didn't finish,
+       # just to delete the many subdirectories created.
+       [ ! -d "${BASE}/d1" ] && skip "test_51b() not run" && return 0
+
+       # for ldiskfs the nlink count should be 1, but this is OSD specific
+       # and so this is listed for informational purposes only
+       echo "nlink before: $(stat -c %h $BASE), created before: $NUMTEST"
+       unlinkmany -d $BASE/d $DELETE
+       RC=$?
 
-        # for ldiskfs the nlink count should be 1, but this is OSD specific
-        # and so this is listed for informational purposes only
-        log "nlink before: $(stat -c %h $BASE)"
-        unlinkmany -d $BASE/t- $DELETE ||
-                error "unlink of first $DELETE subdirs failed"
+       if [ $RC -ne 0 ]; then
+               if [ "$NUMPREV" == "failed" ]; then
+                       skip "previous setup failed"
+                       return 0
+               else
+                       error "unlink of first $DELETE subdirs failed"
+                       return $RC
+               fi
+       fi
 
-        log "nlink between: $(stat -c %h $BASE)"
-        local FOUND=$(ls -l ${BASE} | wc -l)
-        FOUND=$((FOUND - 1))  # trim the first line of ls output
-        [ $FOUND -ne $LEFT ] &&
-                error "can't find subdirs: found only $FOUND/$LEFT"
+       echo "nlink between: $(stat -c %h $BASE)"
+       # trim the first line of ls output
+       local FOUND=$(($(ls -l ${BASE} | wc -l) - 1))
+       [ $FOUND -ne $LEFT ] &&
+               error "can't find subdirs: found only $FOUND/$LEFT"
 
-        unlinkmany -d $BASE/t- $DELETE $LEFT ||
-                error "unlink of second $LEFT subdirs failed"
-        log "nlink after: $(stat -c %h $BASE)"
+       unlinkmany -d $BASE/d $DELETE $LEFT ||
+               error "unlink of second $LEFT subdirs failed"
+       # regardless of whether the backing filesystem tracks nlink accurately
+       # or not, the nlink count shouldn't be more than "." and ".." here
+       local AFTER=$(stat -c %h $BASE)
+       [ $AFTER -gt 2 ] && error "nlink after: $AFTER > 2" ||
+               echo "nlink after: $AFTER"
 }
-run_test 51ba "rmdir .../t-0 --- .../t-$NUMTEST"
+run_test 51ba "verify nlink for many subdirectory cleanup"
 
 test_51bb() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
@@ -3875,6 +4028,11 @@ run_test 56w "check lfs_migrate -c stripe_count works"
 
 test_57a() {
        # note test will not do anything if MDS is not local
+       if [ "$(facet_fstype $SINGLEMDS)" != ldiskfs ]; then
+               skip "Only applicable to ldiskfs-based MDTs"
+               return
+       fi
+
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
        local MNTDEV="osd*.*MDT*.mntdev"
        DEV=$(do_facet $SINGLEMDS lctl get_param -n $MNTDEV)
@@ -3890,6 +4048,11 @@ test_57a() {
 run_test 57a "verify MDS filesystem created with large inodes =="
 
 test_57b() {
+       if [ "$(facet_fstype $SINGLEMDS)" != ldiskfs ]; then
+               skip "Only applicable to ldiskfs-based MDTs"
+               return
+       fi
+
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
        local dir=$DIR/d57b
 
@@ -4020,7 +4183,7 @@ test_61() {
        f="$DIR/f61"
        dd if=/dev/zero of=$f bs=`page_size` count=1
        cancel_lru_locks osc
-       multiop $f OSMWUc || error
+       $MULTIOP $f OSMWUc || error
        sync
 }
 run_test 61 "mmap() writes don't make sync hang ================"
@@ -4066,7 +4229,7 @@ test_63b() {
 
        #define OBD_FAIL_OSC_BRW_PREP_REQ        0x406
        lctl set_param fail_loc=0x80000406
-       multiop $DIR/$tfile Owy && \
+       $MULTIOP $DIR/$tfile Owy && \
                error "sync didn't return ENOMEM"
        sync; sleep 2; sync     # do a real sync this time to flush page
        lctl get_param -n llite.*.dump_page_cache | grep locked && \
@@ -4180,7 +4343,7 @@ test_65ib() { # bug12836
 run_test 65ib "getstripe -v on -1 default directory striping"
 
 test_65ic() { # bug12836
-       $LFS find -mtime -1 $MOUNT || error "find $MOUNT failed"
+       $LFS find -mtime -1 $MOUNT > /dev/null || error "find $MOUNT failed"
 }
 run_test 65ic "new find on -1 default directory striping"
 
@@ -4241,7 +4404,8 @@ run_test 65l "lfs find on -1 stripe dir ========================"
 test_66() {
        COUNT=${COUNT:-8}
        dd if=/dev/zero of=$DIR/f66 bs=1k count=$COUNT
-       sync; sleep 1; sync
+       sync; sync_all_data; sync; sync_all_data
+       cancel_lru_locks osc
        BLOCKS=`ls -s $DIR/f66 | awk '{ print $1 }'`
        [ $BLOCKS -ge $COUNT ] || error "$DIR/f66 blocks $BLOCKS < $COUNT"
 }
@@ -4436,11 +4600,11 @@ test_73() {
        pid1=$!
 
        lctl set_param fail_loc=0x80000129
-       multiop $DIR/d73-1/f73-2 Oc &
+       $MULTIOP $DIR/d73-1/f73-2 Oc &
        sleep 1
        lctl set_param fail_loc=0
 
-       multiop $DIR/d73-2/f73-3 Oc &
+       $MULTIOP $DIR/d73-2/f73-3 Oc &
        pid3=$!
 
        kill -USR1 $pid1
@@ -4695,7 +4859,7 @@ test_77i() { # bug 13805
        for VALUE in `lctl get_param osc.*osc-[^mM]*.checksum_type`; do
                PARAM=`echo ${VALUE[0]} | cut -d "=" -f1`
                algo=`lctl get_param -n $PARAM | sed 's/.*\[\(.*\)\].*/\1/g'`
-               [ "$algo" = "crc32" ] || error "algo set to $algo instead of crc32"
+               [ "$algo" = "adler" ] || error "algo set to $algo instead of adler"
        done
        remount_client $MOUNT
 }
@@ -4794,6 +4958,16 @@ test_79() { # bug 12743
 run_test 79 "df report consistency check ======================="
 
 test_80() { # bug 10718
+        # relax strong synchronous semantics for slow backends like ZFS
+        local soc="obdfilter.*.sync_on_lock_cancel"
+        local soc_old=$(do_facet ost1 lctl get_param -n $soc | head -n1)
+        local hosts=
+        if [ "$soc_old" != "never" -a "$FSTYPE" != "ldiskfs" ]; then
+                hosts=$(for host in $(seq -f "ost%g" 1 $OSTCOUNT); do
+                          facet_active_host $host; done | sort -u)
+                do_nodes $hosts lctl set_param $soc=never
+        fi
+
         dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 seek=1M
         sync; sleep 1; sync
         local BEFORE=`date +%s`
@@ -4803,6 +4977,9 @@ test_80() { # bug 10718
         if [ $DIFF -gt 1 ] ; then
                 error "elapsed for 1M@1T = $DIFF"
         fi
+
+        [ -n "$hosts" ] && do_nodes $hosts lctl set_param $soc=$soc_old
+
         true
         rm -f $DIR/$tfile
 }
@@ -4812,11 +4989,11 @@ test_81a() { # LU-456
         remote_ost_nodsh && skip "remote OST with nodsh" && return
         # define OBD_FAIL_OST_MAPBLK_ENOSPC    0x228
         # MUST OR with the OBD_FAIL_ONCE (0x80000000)
-        do_facet ost0 lctl set_param fail_loc=0x80000228
+        do_facet ost1 lctl set_param fail_loc=0x80000228
 
         # write should trigger a retry and success
         $SETSTRIPE -i 0 -c 1 $DIR/$tfile
-        multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
+        $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
         RC=$?
         if [ $RC -ne 0 ] ; then
                 error "write should success, but failed for $RC"
@@ -4828,11 +5005,11 @@ test_81b() { # LU-456
         remote_ost_nodsh && skip "remote OST with nodsh" && return
         # define OBD_FAIL_OST_MAPBLK_ENOSPC    0x228
         # Don't OR with the OBD_FAIL_ONCE (0x80000000)
-        do_facet ost0 lctl set_param fail_loc=0x228
+        do_facet ost1 lctl set_param fail_loc=0x228
 
         # write should retry several times and return -ENOSPC finally
         $SETSTRIPE -i 0 -c 1 $DIR/$tfile
-        multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
+        $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
         RC=$?
         ENOSPC=28
         if [ $RC -ne $ENOSPC ] ; then
@@ -4841,6 +5018,27 @@ test_81b() { # LU-456
 }
 run_test 81b "OST should return -ENOSPC when retry still fails ======="
 
+test_82() { # LU-1031
+       dd if=/dev/zero of=$DIR/$tfile bs=1M count=10
+       local gid1=14091995
+       local gid2=16022000
+
+       multiop_bg_pause $DIR/$tfile OG${gid1}_g${gid1}c || return 1
+       local MULTIPID1=$!
+       multiop_bg_pause $DIR/$tfile O_G${gid2}r10g${gid2}c || return 2
+       local MULTIPID2=$!
+       kill -USR1 $MULTIPID2
+       sleep 2
+       if [[ `ps h -o comm -p $MULTIPID2` == "" ]]; then
+               error "First grouplock does not block second one"
+       else
+               echo "Second grouplock blocks first one"
+       fi
+       kill -USR1 $MULTIPID1
+       wait $MULTIPID1
+       wait $MULTIPID2
+}
+run_test 82 "Basic grouplock test ==============================="
 
 test_99a() {
         [ -z "$(which cvs 2>/dev/null)" ] && skip_env "could not find cvs" && \
@@ -5119,7 +5317,7 @@ test_101d() {
         { skip "Need free space ${size}M, have $space" && return; }
 
     echo Creating ${size}M test file $file
-    dd if=/dev/zero of=$file bs=1M count=$size
+    dd if=/dev/zero of=$file bs=1M count=$size || error "dd failed"
     echo Cancel LRU locks on lustre client to flush the client cache
     cancel_lru_locks osc
 
@@ -5140,8 +5338,9 @@ test_101d() {
     echo read-ahead disabled time read $time_ra_OFF
     echo read-ahead enabled  time read $time_ra_ON
 
-    set_read_ahead $old_READAHEAD
-    rm -f $file
+       set_read_ahead $old_READAHEAD
+       rm -f $file
+       wait_delete_completed
 
     [ $time_ra_ON -lt $time_ra_OFF ] ||
         error "read-ahead enabled  time read (${time_ra_ON}s) is more than
@@ -5525,6 +5724,22 @@ test_102k() {
 }
 run_test 102k "setfattr without parameter of value shouldn't cause a crash"
 
+test_102l() {
+       # LU-532 trusted. xattr is invisible to non-root
+       local testfile=$DIR/$tfile
+
+       touch $testfile
+
+       echo "listxattr as user..."
+       chown $RUNAS_ID $testfile
+       $RUNAS getfattr -d -m '.*' $testfile 2>&1 |
+           grep -q "trusted" &&
+               error "$testfile trusted xattrs are user visible"
+
+       return 0;
+}
+run_test 102l "listxattr filter test =================================="
+
 cleanup_test102
 
 run_acl_subtest()
@@ -5736,9 +5951,9 @@ test_115() {
            cut -c11-20)
 
        # don't return an error
-        [ $OSTIO_post -eq $OSTIO_pre ] && echo \
-           "WARNING: No new ll_ost_io threads were created ($OSTIO_pre)" &&\
-           echo "This may be fine, depending on what ran before this test" &&\
+        [ $OSTIO_post == $OSTIO_pre ] && echo \
+           "WARNING: No new ll_ost_io threads were created ($OSTIO_pre)" &&
+           echo "This may be fine, depending on what ran before this test" &&
            echo "and how fast this system is." && return
 
         echo "Started with $OSTIO_pre threads, ended with $OSTIO_post"
@@ -5764,7 +5979,7 @@ free_min_max () {
        echo Max free space: OST $MAXI: $MAXV
 }
 
-test_116() {
+test_116a() { # was previously test_116()
        [ "$OSTCOUNT" -lt "2" ] && skip_env "$OSTCOUNT < 2 OSTs" && return
 
        echo -n "Free space priority "
@@ -5847,7 +6062,21 @@ test_116() {
 
        rm -rf $DIR/$tdir
 }
-run_test 116 "stripe QOS: free space balance ==================="
+run_test 116a "stripe QOS: free space balance ==================="
+
+test_116b() { # LU-2093
+#define OBD_FAIL_MDS_OSC_CREATE_FAIL     0x147
+       local old_rr
+       old_rr=$(do_facet $SINGLEMDS lctl get_param -n lov.*mdtlov*.qos_threshold_rr)
+       do_facet $SINGLEMDS lctl set_param lov.*mdtlov*.qos_threshold_rr 0
+       mkdir -p $DIR/$tdir
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x147
+       createmany -o $DIR/$tdir/f- 20 || error "can't create"
+       do_facet $SINGLEMDS lctl set_param fail_loc=0
+       rm -rf $DIR/$tdir
+       do_facet $SINGLEMDS lctl set_param lov.*mdtlov*.qos_threshold_rr $old_rr
+}
+run_test 116b "QoS shouldn't LBUG if not enough OSTs found on the 2nd pass"
 
 test_117() # bug 10891
 {
@@ -5886,7 +6115,7 @@ test_118a() #bug 11710
 {
        reset_async
 
-       multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
+       $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
        DIRTY=$(lctl get_param -n llite.*.dump_page_cache | grep -c dirty)
         WRITEBACK=$(lctl get_param -n llite.*.dump_page_cache | grep -c writeback)
 
@@ -5906,7 +6135,7 @@ test_118b()
 
        #define OBD_FAIL_OST_ENOENT 0x217
        set_nodes_failloc "$(osts_nodes)" 0x217
-       multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
+       $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
        RC=$?
        set_nodes_failloc "$(osts_nodes)" 0
         DIRTY=$(lctl get_param -n llite.*.dump_page_cache | grep -c dirty)
@@ -5927,7 +6156,7 @@ test_118b()
 
        # Due to the above error the OSC will issue all RPCs syncronously
        # until a subsequent RPC completes successfully without error.
-       multiop $DIR/$tfile Ow4096yc
+       $MULTIOP $DIR/$tfile Ow4096yc
        rm -f $DIR/$tfile
 
        return 0
@@ -5944,7 +6173,7 @@ test_118c()
        set_nodes_failloc "$(osts_nodes)" 0x216
 
        # multiop should block due to fsync until pages are written
-       multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c &
+       $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c &
        MULTIPID=$!
        sleep 1
 
@@ -5987,7 +6216,7 @@ test_118d()
        #define OBD_FAIL_OST_BRW_PAUSE_BULK
        set_nodes_failloc "$(osts_nodes)" 0x214
        # multiop should block due to fsync until pages are written
-       multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c &
+       $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c &
        MULTIPID=$!
        sleep 1
 
@@ -6024,7 +6253,7 @@ test_118f() {
         lctl set_param fail_loc=0x8000040a
 
        # Should simulate EINVAL error which is fatal
-        multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
+        $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
         RC=$?
        if [[ $RC -eq 0 ]]; then
                error "Must return error due to dropped pages, rc=$RC"
@@ -6059,7 +6288,7 @@ test_118g() {
        lctl set_param fail_loc=0x406
 
        # simulate local -ENOMEM
-       multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
+       $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
        RC=$?
 
        lctl set_param fail_loc=0
@@ -6095,7 +6324,7 @@ test_118h() {
        #define OBD_FAIL_OST_BRW_WRITE_BULK      0x20e
         set_nodes_failloc "$(osts_nodes)" 0x20e
        # Should simulate ENOMEM error which is recoverable and should be handled by timeout
-        multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
+        $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
         RC=$?
 
         set_nodes_failloc "$(osts_nodes)" 0
@@ -6122,6 +6351,8 @@ test_118h() {
 }
 run_test 118h "Verify timeout in handling recoverables errors  =========="
 
+[ "$SLOW" = "no" ] && [ -n "$OLD_RESENDCOUNT" ] && set_resend_count $OLD_RESENDCOUNT
+
 test_118i() {
        remote_ost_nodsh && skip "remote OST with nodsh" && return
 
@@ -6131,7 +6362,7 @@ test_118i() {
         set_nodes_failloc "$(osts_nodes)" 0x20e
 
        # Should simulate ENOMEM error which is recoverable and should be handled by timeout
-        multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c &
+        $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c &
        PID=$!
        sleep 5
        set_nodes_failloc "$(osts_nodes)" 0
@@ -6160,6 +6391,8 @@ test_118i() {
 }
 run_test 118i "Fix error before timeout in recoverable error  =========="
 
+[ "$SLOW" = "no" ] && set_resend_count 4
+
 test_118j() {
        remote_ost_nodsh && skip "remote OST with nodsh" && return
 
@@ -6169,7 +6402,7 @@ test_118j() {
         set_nodes_failloc "$(osts_nodes)" 0x220
 
        # return -EIO from OST
-        multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
+        $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
         RC=$?
         set_nodes_failloc "$(osts_nodes)" 0x0
        if [[ $RC -eq 0 ]]; then
@@ -6221,7 +6454,7 @@ test_118l()
 {
        # LU-646
        mkdir -p $DIR/$tdir
-       multiop $DIR/$tdir Dy || error "fsync dir failed"
+       $MULTIOP $DIR/$tdir Dy || error "fsync dir failed"
        rm -rf $DIR/$tdir
 }
 run_test 118l "fsync dir ========="
@@ -6251,7 +6484,7 @@ test_119b() # bug 11737
         $SETSTRIPE -c 2 $DIR/$tfile || error "setstripe failed"
         dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 seek=1 || error "dd failed"
         sync
-        multiop $DIR/$tfile oO_RDONLY:O_DIRECT:r$((2048 * 1024)) || \
+        $MULTIOP $DIR/$tfile oO_RDONLY:O_DIRECT:r$((2048 * 1024)) || \
                 error "direct read failed"
         rm -f $DIR/$tfile
 }
@@ -6876,7 +7109,10 @@ set_dir_limits () {
        done
 }
 test_129() {
-       [ "$FSTYPE" != "ldiskfs" ] && skip "not needed for FSTYPE=$FSTYPE" && return 0
+       if [ "$(facet_fstype $SINGLEMDS)" != ldiskfs ]; then
+               skip "Only applicable to ldiskfs-based MDTs"
+               return
+       fi
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
 
        EFBIG=27
@@ -6889,7 +7125,7 @@ test_129() {
        I=0
        J=0
        while [ ! $I -gt $((MAX * MDSCOUNT)) ]; do
-               multiop $DIR/$tdir/$J Oc
+               $MULTIOP $DIR/$tdir/$J Oc
                rc=$?
                if [ $rc -eq $EFBIG ]; then
                        set_dir_limits 0
@@ -6915,18 +7151,26 @@ cleanup_130() {
 }
 
 test_130a() {
-       filefrag_op=$(filefrag -e 2>&1 | grep "invalid option")
-       [ -n "$filefrag_op" ] && skip "filefrag does not support FIEMAP" && return
+       local filefrag_op=$(filefrag -e 2>&1 | grep "invalid option")
+       [ -n "$filefrag_op" ] && skip_env "filefrag does not support FIEMAP" &&
+               return
 
        trap cleanup_130 EXIT RETURN
 
        local fm_file=$DIR/$tfile
        $SETSTRIPE -S 65536 -c 1 $fm_file || error "setstripe on $fm_file"
-       dd if=/dev/zero of=$fm_file bs=65536 count=1 || error "dd failed for $fm_file"
+       dd if=/dev/zero of=$fm_file bs=65536 count=1 ||
+               error "dd failed for $fm_file"
 
-       filefrag -ves $fm_file || error "filefrag $fm_file failed"
-       filefrag_op=`filefrag -ve $fm_file | grep -A 100 "ext:" | grep -v "ext:" | grep -v "found"`
+       # LU-1795: test filefrag/FIEMAP once, even if unsupported
+       filefrag -ves $fm_file
+       RC=$?
+       [ "$(facet_fstype ost$(($($GETSTRIPE -i $fm_file) + 1)))" = "zfs" ] &&
+               skip "ORI-366/LU-1941: FIEMAP unimplemented on ZFS" && return
+       [ $RC != 0 ] && error "filefrag $fm_file failed"
 
+       filefrag_op=$(filefrag -ve $fm_file | grep -A 100 "ext:" |
+                     grep -v "ext:" | grep -v "found")
        lun=$($GETSTRIPE -i $fm_file)
 
        start_blk=`echo $filefrag_op | cut -d: -f2 | cut -d. -f1`
@@ -6957,21 +7201,28 @@ test_130a() {
 run_test 130a "FIEMAP (1-stripe file)"
 
 test_130b() {
-       [ "$OSTCOUNT" -lt "2" ] && skip_env "skipping FIEMAP on 2-stripe file test" && return
+       [ "$OSTCOUNT" -lt "2" ] &&
+               skip_env "skipping FIEMAP on 2-stripe file test" && return
 
-       filefrag_op=$(filefrag -e 2>&1 | grep "invalid option")
-       [ -n "$filefrag_op" ] && skip "filefrag does not support FIEMAP" && return
+       local filefrag_op=$(filefrag -e 2>&1 | grep "invalid option")
+       [ -n "$filefrag_op" ] && skip_env "filefrag does not support FIEMAP" &&
+               return
 
        trap cleanup_130 EXIT RETURN
 
        local fm_file=$DIR/$tfile
        $SETSTRIPE -S 65536 -c 2 $fm_file || error "setstripe on $fm_file"
-       dd if=/dev/zero of=$fm_file bs=1M count=2 || error "dd failed on $fm_file"
+       [ "$(facet_fstype ost$(($($GETSTRIPE -i $fm_file) + 1)))" = "zfs" ] &&
+               skip "ORI-366/LU-1941: FIEMAP unimplemented on ZFS" && return
+
+       dd if=/dev/zero of=$fm_file bs=1M count=2 ||
+               error "dd failed on $fm_file"
 
        filefrag -ves $fm_file || error "filefrag $fm_file failed"
-       filefrag_op=`filefrag -ve $fm_file | grep -A 100 "ext:" | grep -v "ext:" | grep -v "found"`
+       filefrag_op=$(filefrag -ve $fm_file | grep -A 100 "ext:" |
+                     grep -v "ext:" | grep -v "found")
 
-       last_lun=`echo $filefrag_op | cut -d: -f5`
+       last_lun=$(echo $filefrag_op | cut -d: -f5)
 
        IFS=$'\n'
        tot_len=0
@@ -7006,15 +7257,20 @@ test_130b() {
 run_test 130b "FIEMAP (2-stripe file)"
 
 test_130c() {
-       [ "$OSTCOUNT" -lt "2" ] && skip_env "skipping FIEMAP on 2-stripe file with hole test" && return
+       [ "$OSTCOUNT" -lt "2" ] &&
+               skip_env "skipping FIEMAP on 2-stripe file" && return
 
        filefrag_op=$(filefrag -e 2>&1 | grep "invalid option")
-       [ -n "$filefrag_op" ] && skip "filefrag does not support FIEMAP" && return
+       [ -n "$filefrag_op" ] && skip "filefrag does not support FIEMAP" &&
+               return
 
        trap cleanup_130 EXIT RETURN
 
        local fm_file=$DIR/$tfile
        $SETSTRIPE -S 65536 -c 2 $fm_file || error "setstripe on $fm_file"
+       [ "$(facet_fstype ost$(($($GETSTRIPE -i $fm_file) + 1)))" = "zfs" ] &&
+               skip "ORI-366/LU-1941: FIEMAP unimplemented on ZFS" && return
+
        dd if=/dev/zero of=$fm_file seek=1 bs=1M count=1 || error "dd failed on $fm_file"
 
        filefrag -ves $fm_file || error "filefrag $fm_file failed"
@@ -7070,6 +7326,8 @@ test_130d() {
 
        local fm_file=$DIR/$tfile
        $SETSTRIPE -S 65536 -c $OSTCOUNT $fm_file||error "setstripe on $fm_file"
+       [ "$(facet_fstype ost$(($($GETSTRIPE -i $fm_file) + 1)))" = "zfs" ] &&
+               skip "ORI-366/LU-1941: FIEMAP unimplemented on ZFS" && return
        dd if=/dev/zero of=$fm_file bs=1M count=$OSTCOUNT || error "dd failed on $fm_file"
 
        filefrag -ves $fm_file || error "filefrag $fm_file failed"
@@ -7119,6 +7377,9 @@ test_130e() {
 
        local fm_file=$DIR/$tfile
        $SETSTRIPE -S 131072 -c 2 $fm_file || error "setstripe on $fm_file"
+       [ "$(facet_fstype ost$(($($GETSTRIPE -i $fm_file) + 1)))" = "zfs" ] &&
+               skip "ORI-366/LU-1941: FIEMAP unimplemented on ZFS" && return
+
        NUM_BLKS=512
        EXPECTED_LEN=$(( (NUM_BLKS / 2) * 64 ))
        for ((i = 0; i < $NUM_BLKS; i++))
@@ -7358,8 +7619,11 @@ test_133b() {
        chmod 444 ${testdir}/${tfile} || error "chmod failed"
        check_stats $SINGLEMDS "setattr" 1
        do_facet $SINGLEMDS $LCTL set_param mdt.*.md_stats=clear
-       ls -l ${testdir}/${tfile} > /dev/null|| error "ls failed"
-       check_stats $SINGLEMDS "getattr" 1
+       if [ $(lustre_version_code $SINGLEMDS) -ne $(version_code 2.2.0) ]
+       then            # LU-1740
+               ls -l ${testdir}/${tfile} > /dev/null|| error "ls failed"
+               check_stats $SINGLEMDS "getattr" 1
+       fi
        $LFS df || error "lfs failed"
        check_stats $SINGLEMDS "statfs" 1
 
@@ -7377,6 +7641,7 @@ test_133c() {
        $SETSTRIPE -c 1 -i 0 ${testdir}/${tfile}
        sync
        cancel_lru_locks osc
+       wait_delete_completed
 
        # clear stats.
        do_facet $SINGLEMDS $LCTL set_param mdt.*.md_stats=clear
@@ -7394,6 +7659,7 @@ test_133c() {
        check_stats ost "punch" 1
 
        rm -f ${testdir}/${tfile} || error "file remove failed"
+       wait_delete_completed
        check_stats ost "destroy" 1
 
        rm -rf $DIR/${tdir}
@@ -7462,22 +7728,24 @@ test_133d() {
     mkdir -p ${testdir2} || error "mkdir failed"
 
     createmany -o $testdir1/test 512 || error "createmany failed"
-    local testdir1_size=$(ls -l $DIR/${tdir} |
-                          awk '/stats_testdir1/ {print $5}')
-    local testdir2_size=$(ls -l $DIR/${tdir} |
-                          awk '/stats_testdir2/ {print $5}')
 
-    testdir1_size=$(order_2 $testdir1_size)
-    testdir2_size=$(order_2 $testdir2_size)
+       # check samedir rename size
+       mv ${testdir1}/test0 ${testdir1}/test_0
+
+       local testdir1_size=$(ls -l $DIR/${tdir} |
+               awk '/stats_testdir1/ {print $5}')
+       local testdir2_size=$(ls -l $DIR/${tdir} |
+               awk '/stats_testdir2/ {print $5}')
 
-    testdir1_size=$(size_in_KMGT $testdir1_size)
-    testdir2_size=$(size_in_KMGT $testdir2_size)
+       testdir1_size=$(order_2 $testdir1_size)
+       testdir2_size=$(order_2 $testdir2_size)
 
-    echo "source rename dir size: ${testdir1_size}"
-    echo "target rename dir size: ${testdir2_size}"
+       testdir1_size=$(size_in_KMGT $testdir1_size)
+       testdir2_size=$(size_in_KMGT $testdir2_size)
+
+       echo "source rename dir size: ${testdir1_size}"
+       echo "target rename dir size: ${testdir2_size}"
 
-    # check samedir rename size
-    mv ${testdir1}/test0 ${testdir1}/test_0
     local cmd="do_facet $SINGLEMDS $LCTL get_param mdt.*.rename_stats"
     eval $cmd || error "$cmd failed"
     local samedir=$($cmd | grep 'same_dir')
@@ -7490,6 +7758,21 @@ test_133d() {
 
     # check crossdir rename size
     mv ${testdir1}/test_0 ${testdir2}/test_0
+
+       testdir1_size=$(ls -l $DIR/${tdir} |
+               awk '/stats_testdir1/ {print $5}')
+       testdir2_size=$(ls -l $DIR/${tdir} |
+               awk '/stats_testdir2/ {print $5}')
+
+       testdir1_size=$(order_2 $testdir1_size)
+       testdir2_size=$(order_2 $testdir2_size)
+
+       testdir1_size=$(size_in_KMGT $testdir1_size)
+       testdir2_size=$(size_in_KMGT $testdir2_size)
+
+       echo "source rename dir size: ${testdir1_size}"
+       echo "target rename dir size: ${testdir2_size}"
+
     eval $cmd || error "$cmd failed"
     local crossdir=$($cmd | grep 'crossdir')
     local src_sample=$(get_rename_size $testdir1_size)
@@ -7507,8 +7790,9 @@ test_140() { #bug-17379
         cd $DIR/$tdir || error "Changing to $DIR/$tdir"
         cp /usr/bin/stat . || error "Copying stat to $DIR/$tdir"
 
-        # VFS limits max symlink depth to 5(4KSTACK) or 7(8KSTACK) or 8
-        local i=0
+       # VFS limits max symlink depth to 5(4KSTACK) or 7(8KSTACK) or 8
+       # For kernel > 3.5, bellow only tests consecutive symlink (MAX 40)
+       local i=0
         while i=`expr $i + 1`; do
                 mkdir -p $i || error "Creating dir $i"
                 cd $i || error "Changing to $i"
@@ -7528,7 +7812,14 @@ test_140() { #bug-17379
         done
         i=`expr $i - 1`
         echo "The symlink depth = $i"
-        [ $i -eq 5 -o $i -eq 7 -o $i -eq 8 ] || error "Invalid symlink depth"
+       [ $i -eq 5 -o $i -eq 7 -o $i -eq 8 -o $i -eq 40 ] ||
+                                       error "Invalid symlink depth"
+
+       # Test recursive symlink
+       ln -s symlink_self symlink_self
+       $OPENFILE -f O_RDONLY symlink_self >/dev/null 2>&1; ret=$?
+       echo "open symlink_self returns $ret"
+       [ $ret -eq 40 ] || error "recursive symlink doesn't return -ELOOP"
 }
 run_test 140 "Check reasonable stack depth (shouldn't LBUG) ===="
 
@@ -7564,44 +7855,43 @@ test_150() {
 run_test 150 "truncate/append tests"
 
 function roc_hit() {
-    local list=$(comma_list $(osts_nodes))
+       local list=$(comma_list $(osts_nodes))
 
-    ACCNUM=$(do_nodes $list $LCTL get_param -n obdfilter.*.stats | \
-        awk '/'cache_hit'/ {sum+=$2} END {print sum}')
-    echo $ACCNUM
+       echo $(get_obdfilter_param $list '' stats |
+              awk '/'cache_hit'/ {sum+=$2} END {print sum}')
 }
 
 function set_cache() {
-    local on=1
+       local on=1
 
-    if [ "$2" == "off" ]; then
-        on=0;
-    fi
-    local list=$(comma_list $(osts_nodes))
-    do_nodes $list lctl set_param obdfilter.*.${1}_cache_enable $on
+       if [ "$2" == "off" ]; then
+               on=0;
+       fi
+       local list=$(comma_list $(osts_nodes))
+       set_obdfilter_param $list '' $1_cache_enable $on
 
-    cancel_lru_locks osc
+       cancel_lru_locks osc
 }
 
 test_151() {
-        remote_ost_nodsh && skip "remote OST with nodsh" && return
+       remote_ost_nodsh && skip "remote OST with nodsh" && return
 
-        local CPAGES=3
-        local list=$(comma_list $(osts_nodes))
+       local CPAGES=3
+       local list=$(comma_list $(osts_nodes))
 
-        # check whether obdfilter is cache capable at all
-        if ! do_nodes $list $LCTL get_param -n obdfilter.*.read_cache_enable > /dev/null; then
-                echo "not cache-capable obdfilter"
-                return 0
-        fi
+       # check whether obdfilter is cache capable at all
+       if ! get_obdfilter_param $list '' read_cache_enable >/dev/null; then
+               echo "not cache-capable obdfilter"
+               return 0
+       fi
 
-        # check cache is enabled on all obdfilters
-        if do_nodes $list $LCTL get_param -n obdfilter.*.read_cache_enable | grep 0 >&/dev/null; then
-                echo "oss cache is disabled"
-                return 0
-        fi
+       # check cache is enabled on all obdfilters
+       if get_obdfilter_param $list '' read_cache_enable | grep 0; then
+               echo "oss cache is disabled"
+               return 0
+       fi
 
-        do_nodes $list $LCTL set_param -n obdfilter.*.writethrough_cache_enable 1
+       set_obdfilter_param $list '' writethrough_cache_enable 1
 
         # pages should be in the case right after write
         dd if=/dev/urandom of=$DIR/$tfile bs=4k count=$CPAGES || error "dd failed"
@@ -7615,7 +7905,7 @@ test_151() {
 
         # the following read invalidates the cache
         cancel_lru_locks osc
-        do_nodes $list $LCTL set_param -n obdfilter.*.read_cache_enable 0
+       set_obdfilter_param $list '' read_cache_enable 0
         cat $DIR/$tfile >/dev/null
 
         # now data shouldn't be found in the cache
@@ -7627,7 +7917,7 @@ test_151() {
                 error "IN CACHE: before: $BEFORE, after: $AFTER"
         fi
 
-        do_nodes $list $LCTL set_param -n obdfilter.*.read_cache_enable 1
+       set_obdfilter_param $list '' read_cache_enable 1
         rm -f $DIR/$tfile
 }
 run_test 151 "test cache on oss and controls ==============================="
@@ -7656,11 +7946,14 @@ test_152() {
 run_test 152 "test read/write with enomem ============================"
 
 test_153() {
-        multiop $DIR/$tfile Ow4096Ycu || error "multiop failed"
+        $MULTIOP $DIR/$tfile Ow4096Ycu || error "multiop failed"
 }
 run_test 153 "test if fdatasync does not crash ======================="
 
 test_154() {
+       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.2.51) ]] ||
+               { skip "Need MDS version at least 2.2.51"; return 0; }
+
        cp /etc/hosts $DIR/$tfile
 
        fid=$($LFS path2fid $DIR/$tfile)
@@ -7726,6 +8019,46 @@ test_154() {
        touch $DIR/.lustre/fid/$tfile && \
                error "touch $DIR/.lustre/fid/$tfile should fail."
 
+       echo "setxattr to $DIR/.lustre/fid"
+       setfattr -n trusted.name1 -v value1 $DIR/.lustre/fid &&
+               error "setxattr should fail."
+
+       echo "listxattr for $DIR/.lustre/fid"
+       getfattr -d -m "^trusted" $DIR/.lustre/fid &&
+               error "listxattr should fail."
+
+       echo "delxattr from $DIR/.lustre/fid"
+       setfattr -x trusted.name1 $DIR/.lustre/fid &&
+               error "delxattr should fail."
+
+       echo "touch invalid fid: $DIR/.lustre/fid/[0x200000400:0x2:0x3]"
+       touch $DIR/.lustre/fid/[0x200000400:0x2:0x3] &&
+               error "touch invalid fid should fail."
+
+       echo "touch non-normal fid: $DIR/.lustre/fid/[0x1:0x2:0x0]"
+       touch $DIR/.lustre/fid/[0x1:0x2:0x0] &&
+               error "touch non-normal fid should fail."
+
+       echo "rename $tdir to $DIR/.lustre/fid"
+       mrename $DIR/$tdir $DIR/.lustre/fid &&
+               error "rename to $DIR/.lustre/fid should fail."
+
+       echo "rename .lustre to itself"
+       fid=$($LFS path2fid $DIR)
+       mrename $DIR/.lustre $DIR/.lustre/fid/$fid/.lustre &&
+               error "rename .lustre to itself should fail."
+
+       $OPENFILE -f O_LOV_DELAY_CREATE:O_CREAT $DIR/$tfile-2
+       fid=$($LFS path2fid $DIR/$tfile-2)
+       echo "cp /etc/passwd $DIR/.lustre/fid/$fid"
+       cp /etc/passwd $DIR/.lustre/fid/$fid &&
+               error "create lov data thru .lustre should fail."
+       echo "cp /etc/passwd $DIR/$tfile-2"
+       cp /etc/passwd $DIR/$tfile-2 || error "copy to $DIR/$tfile-2 failed."
+       echo "diff /etc/passwd $DIR/.lustre/fid/$fid"
+       diff /etc/passwd $DIR/.lustre/fid/$fid ||
+               error "diff /etc/passwd $DIR/.lustre/fid/$fid failed."
+
        echo "Open-by-FID succeeded"
 }
 run_test 154 "Open-by-FID"
@@ -8209,11 +8542,11 @@ run_test 163 "kernel <-> userspace comms"
 test_169() {
        # do directio so as not to populate the page cache
        log "creating a 10 Mb file"
-       multiop $DIR/$tfile oO_CREAT:O_DIRECT:O_RDWR:w$((10*1048576))c || error "multiop failed while creating a file"
+       $MULTIOP $DIR/$tfile oO_CREAT:O_DIRECT:O_RDWR:w$((10*1048576))c || error "multiop failed while creating a file"
        log "starting reads"
        dd if=$DIR/$tfile of=/dev/null bs=4096 &
        log "truncating the file"
-       multiop $DIR/$tfile oO_TRUNC:c || error "multiop failed while truncating the file"
+       $MULTIOP $DIR/$tfile oO_TRUNC:c || error "multiop failed while truncating the file"
        log "killing dd"
        kill %+ || true # reads might have finished
        echo "wait until dd is finished"
@@ -8399,190 +8732,326 @@ test_181() { # bug 22177
 }
 run_test 181 "Test open-unlinked dir ========================"
 
-# OST pools tests
-POOL=${POOL:-cea1}
-TGT_COUNT=$OSTCOUNT
-TGTPOOL_FIRST=1
-TGTPOOL_MAX=$(($TGT_COUNT - 1))
-TGTPOOL_STEP=2
-TGTPOOL_LIST=`seq $TGTPOOL_FIRST $TGTPOOL_STEP $TGTPOOL_MAX`
-POOL_ROOT=${POOL_ROOT:-$DIR/d200.pools}
-POOL_DIR_NAME=dir_tst
-POOL_DIR=$POOL_ROOT/$POOL_DIR_NAME
-POOL_FILE=$POOL_ROOT/file_tst
+test_182() {
+       # disable MDC RPC lock wouldn't crash client
+       local fcount=1000
+       local tcount=4
+
+       mkdir -p $DIR/$tdir || error "creating dir $DIR/$tdir"
+#define OBD_FAIL_MDC_RPCS_SEM          0x804
+       $LCTL set_param fail_loc=0x804
+
+       for (( i=0; i < $tcount; i++ )) ; do
+               mkdir $DIR/$tdir/$i
+               createmany -o $DIR/$tdir/$i/f- $fcount &
+       done
+       wait
+
+       for (( i=0; i < $tcount; i++ )) ; do
+               unlinkmany $DIR/$tdir/$i/f- $fcount &
+       done
+       wait
+
+       rm -rf $DIR/$tdir
+
+       $LCTL set_param fail_loc=0
+}
+run_test 182 "Disable MDC RPCs semaphore wouldn't crash client ================"
 
+# OST pools tests
 check_file_in_pool()
 {
-       file=$1
-       res=$($GETSTRIPE $file | grep 0x | cut -f2)
+       local file=$1
+       local pool=$2
+       local tlist="$3"
+       local res=$($GETSTRIPE $file | grep 0x | cut -f2)
        for i in $res
        do
-               found=$(echo :$TGTPOOL_LIST: | tr " " ":"  | grep :$i:)
-               if [[ "$found" == "" ]]
-               then
-                       echo "pool list: $TGTPOOL_LIST"
-                       echo "striping: $res"
-                       error "$file not allocated in $POOL"
-                       return 1
-               fi
+               for t in $tlist ; do
+                       [ "$i" -eq "$t" ] && continue 2
+               done
+
+               echo "pool list: $tlist"
+               echo "striping: $res"
+               error_noexit "$file not allocated in $pool"
+               return 1
        done
        return 0
 }
 
-trap "cleanup_pools $FSNAME" EXIT
+pool_add() {
+       echo "Creating new pool"
+       local pool=$1
 
-test_200a() {
-       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
-    create_pool $FSNAME.$POOL || return $?
-       [ $($LFS pool_list $FSNAME | grep -c $POOL) -eq 1 ] ||
-               error "$POOL not in lfs pool_list"
+       create_pool $FSNAME.$pool ||
+               { error_noexit "No pool created, result code $?"; return 1; }
+       [ $($LFS pool_list $FSNAME | grep -c $pool) -eq 1 ] ||
+               { error_noexit "$pool not in lfs pool_list"; return 2; }
 }
-run_test 200a "Create new pool =========================================="
 
-test_200b() {
-       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
-       TGT=$(for i in $TGTPOOL_LIST; do printf "$FSNAME-OST%04x_UUID " $i; done)
-       do_facet mgs $LCTL pool_add $FSNAME.$POOL \
-               $FSNAME-OST[$TGTPOOL_FIRST-$TGTPOOL_MAX/$TGTPOOL_STEP]
-       wait_update $HOSTNAME "lctl get_param -n lov.$FSNAME-*.pools.$POOL | sort -u | tr '\n' ' ' " "$TGT" ||
-               error "Add to pool failed"
-       local lfscount=$($LFS pool_list $FSNAME.$POOL | grep -c "\-OST")
-       local addcount=$((($TGTPOOL_MAX - $TGTPOOL_FIRST) / $TGTPOOL_STEP + 1))
-       [ $lfscount -eq $addcount ] ||
-               error "lfs pool_list bad ost count $lfscount != $addcount"
-}
-run_test 200b "Add targets to a pool ===================================="
-
-test_200c() {
-       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
-       mkdir -p $POOL_DIR
-       $SETSTRIPE -c 2 -p $POOL $POOL_DIR
-       [ $? = 0 ] || error "Cannot set pool $POOL to $POOL_DIR"
-       # b-19919 test relative path works well
-       mkdir -p $POOL_DIR/$POOL_DIR_NAME
-       cd $POOL_DIR
-       $SETSTRIPE -c 2 -p $POOL $POOL_DIR_NAME
-       [ $? = 0 ] || error "Cannot set pool $POOL to $POOL_DIR/$POOL_DIR_NAME"
-       $SETSTRIPE -c 2 -p $POOL ./$POOL_DIR_NAME
-       [ $? = 0 ] || error "Cannot set pool $POOL to $POOL_DIR/./$POOL_DIR_NAME"
-       $SETSTRIPE -c 2 -p $POOL ../$POOL_DIR_NAME
-       [ $? = 0 ] || error "Cannot set pool $POOL to $POOL_DIR/../$POOL_DIR_NAME"
-       $SETSTRIPE -c 2 -p $POOL ../$POOL_DIR_NAME/$POOL_DIR_NAME
-       [ $? = 0 ] || error "Cannot set pool $POOL to $POOL_DIR/../$POOL_DIR_NAME/$POOL_DIR_NAME"
-       rm -rf $POOL_DIR_NAME; cd -
-}
-run_test 200c "Set pool on a directory ================================="
-
-test_200d() {
-       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
-       res=$($GETSTRIPE --pool $POOL_DIR)
-       [ $res = $POOL ] || error "Pool on $POOL_DIR is $res, not $POOL"
+pool_add_targets() {
+       echo "Adding targets to pool"
+       local pool=$1
+       local first=$2
+       local last=$3
+       local step=${4:-1}
+
+       local list=$(seq $first $step $last)
+
+       local t=$(for i in $list; do printf "$FSNAME-OST%04x_UUID " $i; done)
+       do_facet mgs $LCTL pool_add \
+                       $FSNAME.$pool $FSNAME-OST[$first-$last/$step]
+       wait_update $HOSTNAME "lctl get_param -n lov.$FSNAME-*.pools.$pool \
+                       | sort -u | tr '\n' ' ' " "$t" || { 
+               error_noexit "Add to pool failed"
+               return 1
+       }
+       local lfscount=$($LFS pool_list $FSNAME.$pool | grep -c "\-OST")
+       local addcount=$(((last - first) / step + 1))
+       [ $lfscount -eq $addcount ] || {
+               error_noexit "lfs pool_list bad ost count" \
+                                               "$lfscount != $addcount"
+               return 2
+       }
 }
-run_test 200d "Check pool on a directory ==============================="
 
-test_200e() {
-       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
-       failed=0
-       for i in $(seq -w 1 $(($TGT_COUNT * 3)))
+pool_set_dir() {
+       local pool=$1
+       local tdir=$2
+       echo "Setting pool on directory $tdir"
+
+       $SETSTRIPE -c 2 -p $pool $tdir && return 0
+
+       error_noexit "Cannot set pool $pool to $tdir"
+       return 1
+}
+
+pool_check_dir() {
+       local pool=$1
+       local tdir=$2
+       echo "Checking pool on directory $tdir"
+
+       local res=$($GETSTRIPE --pool $tdir | sed "s/\s*$//")
+       [ "$res" = "$pool" ] && return 0
+
+       error_noexit "Pool on '$tdir' is '$res', not '$pool'"
+       return 1
+}
+
+pool_dir_rel_path() {
+       echo "Testing relative path works well"
+       local pool=$1
+       local tdir=$2
+       local root=$3
+
+       mkdir -p $root/$tdir/$tdir
+       cd $root/$tdir
+       pool_set_dir $pool $tdir          || return 1
+       pool_set_dir $pool ./$tdir        || return 2
+       pool_set_dir $pool ../$tdir       || return 3
+       pool_set_dir $pool ../$tdir/$tdir || return 4
+       rm -rf $tdir; cd - > /dev/null
+}
+
+pool_alloc_files() {
+       echo "Checking files allocation from directory pool"
+       local pool=$1
+       local tdir=$2
+       local count=$3
+       local tlist="$4"
+
+       local failed=0
+       for i in $(seq -w 1 $count)
        do
-               file=$POOL_DIR/file-$i
+               local file=$tdir/file-$i
                touch $file
-               check_file_in_pool $file
-               if [[ $? != 0 ]]
-               then
-                       failed=$(($failed + 1))
-               fi
+               check_file_in_pool $file $pool "$tlist" || \
+                       failed=$((failed + 1))
        done
-       [ "$failed" = 0 ] || error "$failed files not allocated in $POOL"
+       [ "$failed" = 0 ] && return 0
+
+       error_noexit "$failed files not allocated in $pool"
+       return 1
 }
-run_test 200e "Check files allocation from directory pool =============="
 
-test_200f() {
-       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
-       mkdir -p $POOL_FILE
-       failed=0
-       for i in $(seq -w 1 $(($TGT_COUNT * 3)))
+pool_create_files() {
+       echo "Creating files in pool"
+       local pool=$1
+       local tdir=$2
+       local count=$3
+       local tlist="$4"
+
+       mkdir -p $tdir
+       local failed=0
+       for i in $(seq -w 1 $count)
        do
-               file=$POOL_FILE/spoo-$i
-               $SETSTRIPE -p $POOL $file
-               check_file_in_pool $file
-               if [[ $? != 0 ]]
-               then
-                       failed=$(($failed + 1))
-               fi
+               local file=$tdir/spoo-$i
+               $SETSTRIPE -p $pool $file
+               check_file_in_pool $file $pool "$tlist" || \
+                       failed=$((failed + 1))
        done
-       [ "$failed" = 0 ] || error "$failed files not allocated in $POOL"
+       [ "$failed" = 0 ] && return 0
+
+       error_noexit "$failed files not allocated in $pool"
+       return 1
 }
-run_test 200f "Create files in a pool ==================================="
 
-test_200g() {
-       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
-       TGT=$($LCTL get_param -n lov.$FSNAME-clilov-*.pools.$POOL | tr '\n' ' ')
-       res=$($LFS df --pool $FSNAME.$POOL | awk '{print $1}' | grep "$FSNAME-OST" | tr '\n' ' ')
-       [ "$res" = "$TGT" ] || error "Pools OSTs '$TGT' is not '$res' that lfs df reports"
+pool_lfs_df() {
+       echo "Checking 'lfs df' output"
+       local pool=$1
+
+       local t=$($LCTL get_param -n lov.$FSNAME-clilov-*.pools.$pool |
+                       tr '\n' ' ')
+       local res=$($LFS df --pool $FSNAME.$pool |
+                       awk '{print $1}' |
+                       grep "$FSNAME-OST" |
+                       tr '\n' ' ')
+       [ "$res" = "$t" ] && return 0
+
+       error_noexit "Pools OSTs '$t' is not '$res' that lfs df reports"
+       return 1
 }
-run_test 200g "lfs df a pool ============================================"
 
-test_200h() { # b=24039
-       mkdir -p $POOL_DIR || error "unable to create $POOL_DIR"
+pool_file_rel_path() {
+       echo "Creating files in a pool with relative pathname"
+       local pool=$1
+       local tdir=$2
 
-       local file="/..$POOL_DIR/$tfile-1"
-       $SETSTRIPE -p $POOL $file || error "unable to create $file"
+       mkdir -p $tdir ||
+               { error_noexit "unable to create $tdir"; return 1 ; }
+       local file="/..$tdir/$tfile-1"
+       $SETSTRIPE -p $pool $file ||
+               { error_noexit "unable to create $file" ; return 2 ; }
 
-       cd $POOL_DIR
-       $SETSTRIPE -p $POOL $tfile-2 || \
-               error "unable to create $tfile-2 in $POOL_DIR"
+       cd $tdir
+       $SETSTRIPE -p $pool $tfile-2 || {
+               error_noexit "unable to create $tfile-2 in $tdir"
+               return 3
+       }
 }
-run_test 200h "Create files in a pool with relative pathname ============"
 
-test_201a() {
-       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
-       TGT=$($LCTL get_param -n lov.$FSNAME-*.pools.$POOL | head -1)
-       do_facet mgs $LCTL pool_remove $FSNAME.$POOL $TGT
-       wait_update $HOSTNAME "lctl get_param -n lov.$FSNAME-*.pools.$POOL | grep $TGT" "" ||
-               error "$TGT not removed from $FSNAME.$POOL"
+pool_remove_first_target() {
+       echo "Removing first target from a pool"
+       local pool=$1
+
+       local pname="lov.$FSNAME-*.pools.$pool"
+       local t=$($LCTL get_param -n $pname | head -1)
+       do_facet mgs $LCTL pool_remove $FSNAME.$pool $t
+       wait_update $HOSTNAME "lctl get_param -n $pname | grep $t" "" || {
+               error_noexit "$t not removed from $FSNAME.$pool"
+               return 1
+       }
 }
-run_test 201a "Remove a target from a pool ============================="
 
-test_201b() {
-       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
-       for TGT in $($LCTL get_param -n lov.$FSNAME-*.pools.$POOL | sort -u)
+pool_remove_all_targets() {
+       echo "Removing all targets from pool"
+       local pool=$1
+       local file=$2
+       local pname="lov.$FSNAME-*.pools.$pool"
+       for t in $($LCTL get_param -n $pname | sort -u)
        do
-               do_facet mgs $LCTL pool_remove $FSNAME.$POOL $TGT
-       done
-       wait_update $HOSTNAME "lctl get_param -n lov.$FSNAME-*.pools.$POOL" "" ||
-               error "Pool $FSNAME.$POOL cannot be drained"
-       # striping on an empty/nonexistant pool should fall back to "pool of everything"
-       touch ${POOL_DIR}/$tfile || error "failed to use fallback striping for empty pool"
+               do_facet mgs $LCTL pool_remove $FSNAME.$pool $t
+       done
+       wait_update $HOSTNAME "lctl get_param -n $pname" "" || {
+               error_noexit "Pool $FSNAME.$pool cannot be drained"
+               return 1
+       }
+       # striping on an empty/nonexistant pool should fall back 
+       # to "pool of everything"
+       touch $file || {
+               error_noexit "failed to use fallback striping for empty pool"
+               return 2
+       }
        # setstripe on an empty pool should fail
-       $SETSTRIPE -p $POOL ${POOL_FILE}/$tfile 2>/dev/null && \
-               error "expected failure when creating file with empty pool"
+       $SETSTRIPE -p $pool $file 2>/dev/null && {
+               error_noexit "expected failure when creating file" \
+                                                       "with empty pool"
+               return 3
+       }
        return 0
 }
-run_test 201b "Remove all targets from a pool =========================="
 
-test_201c() {
-       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
-       do_facet mgs $LCTL pool_destroy $FSNAME.$POOL
+pool_remove() {
+       echo "Destroying pool"
+       local pool=$1
+       local file=$2
+
+       do_facet mgs $LCTL pool_destroy $FSNAME.$pool
 
        sleep 2
-    # striping on an empty/nonexistant pool should fall back to "pool of everything"
-       touch ${POOL_DIR}/$tfile || error "failed to use fallback striping for missing pool"
+       # striping on an empty/nonexistant pool should fall back 
+       # to "pool of everything"
+       touch $file || {
+               error_noexit "failed to use fallback striping for missing pool"
+               return 1
+       }
        # setstripe on an empty pool should fail
-       $SETSTRIPE -p $POOL ${POOL_FILE}/$tfile 2>/dev/null && \
-               error "expected failure when creating file with missing pool"
+       $SETSTRIPE -p $pool $file 2>/dev/null && {
+               error_noexit "expected failure when creating file" \
+                                                       "with missing pool"
+               return 2
+       }
 
        # get param should return err once pool is gone
-       if wait_update $HOSTNAME "lctl get_param -n lov.$FSNAME-*.pools.$POOL 2>/dev/null ||
-                       echo foo" "foo"; then
-               remove_pool_from_list $FSNAME.$POOL
+       if wait_update $HOSTNAME "lctl get_param -n \
+               lov.$FSNAME-*.pools.$pool 2>/dev/null || echo foo" "foo"
+       then
+               remove_pool_from_list $FSNAME.$pool
                return 0
        fi
-       error "Pool $FSNAME.$POOL is not destroyed"
+       error_noexit "Pool $FSNAME.$pool is not destroyed"
+       return 3
 }
-run_test 201c "Remove a pool ============================================"
 
-cleanup_pools $FSNAME
+test_200() {
+       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
+
+       local POOL=${POOL:-cea1}
+       local POOL_ROOT=${POOL_ROOT:-$DIR/d200.pools}
+       local POOL_DIR_NAME=${POOL_DIR_NAME:-dir_tst}
+       # Pool OST targets
+       local first_ost=0
+       local last_ost=$(($OSTCOUNT - 1))
+       local ost_step=2
+       local ost_list=$(seq $first_ost $ost_step $last_ost)
+       local ost_range="$first_ost $last_ost $ost_step"
+       local test_path=$POOL_ROOT/$POOL_DIR_NAME
+       local file_dir=$POOL_ROOT/file_tst
+
+       local rc=0
+       while : ; do
+               # former test_200a test_200b
+               pool_add $POOL                          || { rc=$? ; break; }
+               pool_add_targets  $POOL $ost_range      || { rc=$? ; break; }
+               # former test_200c test_200d
+               mkdir -p $test_path
+               pool_set_dir      $POOL $test_path      || { rc=$? ; break; }
+               pool_check_dir    $POOL $test_path      || { rc=$? ; break; }
+               pool_dir_rel_path $POOL $POOL_DIR_NAME $POOL_ROOT \
+                                                       || { rc=$? ; break; }
+               # former test_200e test_200f
+               local files=$((OSTCOUNT*3))
+               pool_alloc_files  $POOL $test_path $files "$ost_list" \
+                                                       || { rc=$? ; break; }
+               pool_create_files $POOL $file_dir $files "$ost_list" \
+                                                       || { rc=$? ; break; }
+               # former test_200g test_200h
+               pool_lfs_df $POOL                       || { rc=$? ; break; }
+               pool_file_rel_path $POOL $test_path     || { rc=$? ; break; }
+
+               # former test_201a test_201b test_201c
+               pool_remove_first_target $POOL          || { rc=$? ; break; }
+
+               local f=$test_path/$tfile
+               pool_remove_all_targets $POOL $f        || { rc=$? ; break; }
+               pool_remove $POOL $f                    || { rc=$? ; break; }
+               break
+       done
+
+       cleanup_pools
+       return $rc
+}
+run_test 200 "OST pools"
 
 # usage: default_attr <count | size | offset>
 default_attr() {
@@ -8697,6 +9166,120 @@ test_204h() {
 }
 run_test 204h "Print raw stripe count and size ============="
 
+# Figure out which job scheduler is being used, if any,
+# or use a fake one
+if [ -n "$SLURM_JOB_ID" ]; then # SLURM
+       JOBENV=SLURM_JOB_ID
+elif [ -n "$LSB_JOBID" ]; then # Load Sharing Facility
+       JOBENV=LSB_JOBID
+elif [ -n "$PBS_JOBID" ]; then # PBS/Maui/Moab
+       JOBENV=PBS_JOBID
+elif [ -n "$LOADL_STEPID" ]; then # LoadLeveller
+       JOBENV=LOADL_STEP_ID
+elif [ -n "$JOB_ID" ]; then # Sun Grid Engine
+       JOBENV=JOB_ID
+else
+       JOBENV=FAKE_JOBID
+fi
+
+verify_jobstats() {
+       local cmd=$1
+       local target=$2
+
+       # clear old jobstats
+       do_facet $SINGLEMDS lctl set_param mdt.*.job_stats="clear"
+       do_facet ost1 lctl set_param obdfilter.*.job_stats="clear"
+
+       # use a new JobID for this test, or we might see an old one
+       [ "$JOBENV" = "FAKE_JOBID" ] && FAKE_JOBID=test_id.$testnum.$RANDOM
+
+       JOBVAL=${!JOBENV}
+       log "Test: $cmd"
+       log "Using JobID environment variable $JOBENV=$JOBVAL"
+
+       if [ $JOBENV = "FAKE_JOBID" ]; then
+               FAKE_JOBID=$JOBVAL $cmd
+       else
+               $cmd
+       fi
+
+       if [ "$target" = "mdt" -o "$target" = "both" ]; then
+               FACET="$SINGLEMDS" # will need to get MDS number for DNE
+               do_facet $FACET lctl get_param mdt.*.job_stats |
+                       grep $JOBVAL || error "No job stats found on MDT $FACET"
+       fi
+       if [ "$target" = "ost" -o "$target" = "both" ]; then
+               FACET=ost1
+               do_facet $FACET lctl get_param obdfilter.*.job_stats |
+                       grep $JOBVAL || error "No job stats found on OST $FACET"
+       fi
+}
+
+test_205() { # Job stats
+       [ -z "$(lctl get_param -n mdc.*.connect_flags | grep jobstats)" ] &&
+               skip "Server doesn't support jobstats" && return 0
+
+       local cmd
+       OLD_JOBENV=`$LCTL get_param -n jobid_var`
+       if [ $OLD_JOBENV != $JOBENV ]; then
+               do_facet mgs $LCTL conf_param $FSNAME.sys.jobid_var=$JOBENV
+               wait_update $HOSTNAME "$LCTL get_param -n jobid_var" \
+                       $JOBENV || return 1
+       fi
+
+       # mkdir
+       cmd="mkdir $DIR/$tfile"
+       verify_jobstats "$cmd" "mdt"
+       # rmdir
+       cmd="rm -fr $DIR/$tfile"
+       verify_jobstats "$cmd" "mdt"
+       # mknod
+       cmd="mknod $DIR/$tfile c 1 3"
+       verify_jobstats "$cmd" "mdt"
+       # unlink
+       cmd="rm -f $DIR/$tfile"
+       verify_jobstats "$cmd" "mdt"
+       # open & close
+       cmd="$SETSTRIPE -i 0 -c 1 $DIR/$tfile"
+       verify_jobstats "$cmd" "mdt"
+       # setattr
+       cmd="touch $DIR/$tfile"
+       verify_jobstats "$cmd" "both"
+       # write
+       cmd="dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 oflag=sync"
+       verify_jobstats "$cmd" "ost"
+       # read
+       cmd="dd if=$DIR/$tfile of=/dev/null bs=1M count=1 iflag=direct"
+       verify_jobstats "$cmd" "ost"
+       # truncate
+       cmd="$TRUNCATE $DIR/$tfile 0"
+       verify_jobstats "$cmd" "both"
+       # rename
+       cmd="mv -f $DIR/$tfile $DIR/jobstats_test_rename"
+       verify_jobstats "$cmd" "mdt"
+
+       # cleanup
+       rm -f $DIR/jobstats_test_rename
+
+       if [ $OLD_JOBENV != $JOBENV ]; then
+               do_facet mgs $LCTL conf_param $FSNAME.sys.jobid_var=$OLD_JOBENV
+               wait_update $HOSTNAME "$LCTL get_param -n jobid_var" \
+                       $OLD_JOBENV || return 1
+       fi
+}
+run_test 205 "Verify job stats"
+
+# LU-1480, LU-1773 and LU-1657
+test_206() {
+       mkdir -p $DIR/$tdir
+       lfs setstripe -c -1 $DIR/$tdir
+#define OBD_FAIL_LOV_INIT 0x1403
+       $LCTL set_param fail_loc=0xa0001403
+       $LCTL set_param fail_val=1
+       touch $DIR/$tdir/$tfile || true
+}
+run_test 206 "fail lov_init_raid0() doesn't lbug"
+
 test_212() {
        size=`date +%s`
        size=$((size % 8192 + 1))
@@ -8776,12 +9359,12 @@ check_lnet_proc_entry() {
 }
 
 test_215() { # for bugs 18102, 21079, 21517
-       local N='(0|[1-9][0-9]*)'   # non-negative numeric
-       local P='[1-9][0-9]*'       # positive numeric
-       local I='(0|-?[1-9][0-9]*)' # any numeric (0 | >0 | <0)
-       local NET='[a-z][a-z0-9]*'  # LNET net like o2ib2
-       local ADDR='[0-9.]+'        # LNET addr like 10.0.0.1
-       local NID="$ADDR@$NET"      # LNET nid like 10.0.0.1@o2ib2
+       local N='(0|[1-9][0-9]*)'       # non-negative numeric
+       local P='[1-9][0-9]*'           # positive numeric
+       local I='(0|-?[1-9][0-9]*|NA)'  # any numeric (0 | >0 | <0) or NA if no value
+       local NET='[a-z][a-z0-9]*'      # LNET net like o2ib2
+       local ADDR='[0-9.]+'            # LNET addr like 10.0.0.1
+       local NID="$ADDR@$NET"          # LNET nid like 10.0.0.1@o2ib2
 
        local L1 # regexp for 1st line
        local L2 # regexp for 2nd line (optional)
@@ -8844,10 +9427,10 @@ test_215() { # for bugs 18102, 21079, 21517
        # /proc/sys/lnet/nis should look like this:
        # nid status alive refs peer rtr max tx min
        # where nid is a string like 192.168.1.1@tcp2, status is up/down,
-       # alive is numeric (0 or >0 or <0), refs > 0, peer >= 0,
+       # alive is numeric (0 or >0 or <0), refs >= 0, peer >= 0,
        # rtr >= 0, max >=0, tx and min are numeric (0 or >0 or <0).
        L1="^nid +status +alive +refs +peer +rtr +max +tx +min$"
-       BR="^$NID +(up|down) +$I +$P +$N +$N +$N +$I +$I$"
+       BR="^$NID +(up|down) +$I +$N +$N +$N +$N +$I +$I$"
        create_lnet_proc_files "nis"
        check_lnet_proc_entry "nis.out" "/proc/sys/lnet/nis" "$BR" "$L1"
        check_lnet_proc_entry "nis.sys" "lnet.nis" "$BR" "$L1"
@@ -8915,11 +9498,11 @@ run_test 217 "check lctl ping for hostnames with hiphen ('-')"
 test_218() {
        # do directio so as not to populate the page cache
        log "creating a 10 Mb file"
-       multiop $DIR/$tfile oO_CREAT:O_DIRECT:O_RDWR:w$((10*1048576))c || error "multiop failed while creating a file"
+       $MULTIOP $DIR/$tfile oO_CREAT:O_DIRECT:O_RDWR:w$((10*1048576))c || error "multiop failed while creating a file"
        log "starting reads"
        dd if=$DIR/$tfile of=/dev/null bs=4096 &
        log "truncating the file"
-       multiop $DIR/$tfile oO_TRUNC:c || error "multiop failed while truncating the file"
+       $MULTIOP $DIR/$tfile oO_TRUNC:c || error "multiop failed while truncating the file"
        log "killing dd"
        kill %+ || true # reads might have finished
        echo "wait until dd is finished"
@@ -9127,6 +9710,189 @@ test_225b () {
 }
 run_test 225b "Metadata survey sanity with stripe_count = 1"
 
+mcreate_path2fid () {
+       local mode=$1
+       local major=$2
+       local minor=$3
+       local name=$4
+       local desc=$5
+       local path=$DIR/$tdir/$name
+       local fid
+       local rc
+       local fid_path
+
+       $MCREATE --mode=$1 --major=$2 --minor=$3 $path || \
+               error "error: cannot create $desc"
+
+       fid=$($LFS path2fid $path)
+       rc=$?
+       [ $rc -ne 0 ] && error "error: cannot get fid of a $desc"
+
+       fid_path=$($LFS fid2path $DIR $fid)
+       rc=$?
+       [ $rc -ne 0 ] && error "error: cannot get path of a $desc by fid"
+
+       [ "$path" == "$fid_path" ] || \
+               error "error: fid2path returned \`$fid_path', expected \`$path'"
+}
+
+test_226 () {
+       rm -rf $DIR/$tdir
+       mkdir -p $DIR/$tdir
+
+       mcreate_path2fid 0010666 0 0 fifo "FIFO"
+       mcreate_path2fid 0020666 1 3 null "character special file (null)"
+       mcreate_path2fid 0020666 1 255 none "character special file (no device)"
+       mcreate_path2fid 0040666 0 0 dir "directory"
+       mcreate_path2fid 0060666 7 0 loop0 "block special file (loop)"
+       mcreate_path2fid 0100666 0 0 file "regular file"
+       mcreate_path2fid 0120666 0 0 link "symbolic link"
+       mcreate_path2fid 0140666 0 0 sock "socket"
+}
+run_test 226 "call path2fid and fid2path on files of all type"
+
+# LU-1299 Executing or running ldd on a truncated executable does not
+# cause an out-of-memory condition.
+test_227() {
+       dd if=`which date` of=$MOUNT/date bs=1k count=1
+       chmod +x $MOUNT/date
+
+       $MOUNT/date > /dev/null
+       ldd $MOUNT/date > /dev/null
+       rm -f $MOUNT/date
+}
+run_test 227 "running truncated executable does not cause OOM"
+
+# LU-1512 try to reuse idle OI blocks
+test_228a() {
+       [ "$FSTYPE" != "ldiskfs" ] && skip "non-ldiskfs backend" && return
+
+       local MDT_DEV=$(mdsdevname ${SINGLEMDS//mds/})
+       local myDIR=$DIR/$tdir
+
+       mkdir -p $myDIR
+       #define OBD_FAIL_SEQ_EXHAUST             0x1002
+       $LCTL set_param fail_loc=0x80001002
+       createmany -o $myDIR/t- 10000
+       $LCTL set_param fail_loc=0
+       # The guard is current the largest FID holder
+       touch $myDIR/guard
+       local SEQ=$($LFS path2fid $myDIR/guard | awk -F ':' '{print $1}' |
+                   tr -d '[')
+       local IDX=$(($SEQ % 64))
+
+       do_facet $SINGLEMDS sync
+       # Make sure journal flushed.
+       sleep 6
+       local blk1=$(do_facet $SINGLEMDS \
+                    "$DEBUGFS -c -R \\\"stat oi.16.${IDX}\\\" $MDT_DEV" |
+                    grep Blockcount | awk '{print $4}')
+
+       # Remove old files, some OI blocks will become idle.
+       unlinkmany $myDIR/t- 10000
+       # Create new files, idle OI blocks should be reused.
+       createmany -o $myDIR/t- 2000
+       do_facet $SINGLEMDS sync
+       # Make sure journal flushed.
+       sleep 6
+       local blk2=$(do_facet $SINGLEMDS \
+                    "$DEBUGFS -c -R \\\"stat oi.16.${IDX}\\\" $MDT_DEV" |
+                    grep Blockcount | awk '{print $4}')
+
+       [ $blk1 == $blk2 ] || error "old blk1=$blk1, new blk2=$blk2, unmatched!"
+}
+run_test 228a "try to reuse idle OI blocks"
+
+test_228b() {
+       [ "$FSTYPE" != "ldiskfs" ] && skip "non-ldiskfs backend" && return
+
+       local MDT_DEV=$(mdsdevname ${SINGLEMDS//mds/})
+       local myDIR=$DIR/$tdir
+
+       mkdir -p $myDIR
+       #define OBD_FAIL_SEQ_EXHAUST             0x1002
+       $LCTL set_param fail_loc=0x80001002
+       createmany -o $myDIR/t- 10000
+       $LCTL set_param fail_loc=0
+       # The guard is current the largest FID holder
+       touch $myDIR/guard
+       local SEQ=$($LFS path2fid $myDIR/guard | awk -F ':' '{print $1}' |
+                   tr -d '[')
+       local IDX=$(($SEQ % 64))
+
+       do_facet $SINGLEMDS sync
+       # Make sure journal flushed.
+       sleep 6
+       local blk1=$(do_facet $SINGLEMDS \
+                    "$DEBUGFS -c -R \\\"stat oi.16.${IDX}\\\" $MDT_DEV" |
+                    grep Blockcount | awk '{print $4}')
+
+       # Remove old files, some OI blocks will become idle.
+       unlinkmany $myDIR/t- 10000
+
+       # stop the MDT
+       stop $SINGLEMDS || error "Fail to stop MDT."
+       # remount the MDT
+       start $SINGLEMDS $MDT_DEV $MDS_MOUNT_OPTS || error "Fail to start MDT."
+
+       df $MOUNT || error "Fail to df."
+       # Create new files, idle OI blocks should be reused.
+       createmany -o $myDIR/t- 2000
+       do_facet $SINGLEMDS sync
+       # Make sure journal flushed.
+       sleep 6
+       local blk2=$(do_facet $SINGLEMDS \
+                    "$DEBUGFS -c -R \\\"stat oi.16.${IDX}\\\" $MDT_DEV" |
+                    grep Blockcount | awk '{print $4}')
+
+       [ $blk1 == $blk2 ] || error "old blk1=$blk1, new blk2=$blk2, unmatched!"
+}
+run_test 228b "idle OI blocks can be reused after MDT restart"
+
+#LU-1881
+test_228c() {
+       [ "$FSTYPE" != "ldiskfs" ] && skip "non-ldiskfs backend" && return
+
+       local MDT_DEV=$(mdsdevname ${SINGLEMDS//mds/})
+       local myDIR=$DIR/$tdir
+
+       mkdir -p $myDIR
+       #define OBD_FAIL_SEQ_EXHAUST             0x1002
+       $LCTL set_param fail_loc=0x80001002
+       # 20000 files can guarantee there are index nodes in the OI file
+       createmany -o $myDIR/t- 20000
+       $LCTL set_param fail_loc=0
+       # The guard is current the largest FID holder
+       touch $myDIR/guard
+       local SEQ=$($LFS path2fid $myDIR/guard | awk -F ':' '{print $1}' |
+                   tr -d '[')
+       local IDX=$(($SEQ % 64))
+
+       do_facet $SINGLEMDS sync
+       # Make sure journal flushed.
+       sleep 6
+       local blk1=$(do_facet $SINGLEMDS \
+                    "$DEBUGFS -c -R \\\"stat oi.16.${IDX}\\\" $MDT_DEV" |
+                    grep Blockcount | awk '{print $4}')
+
+       # Remove old files, some OI blocks will become idle.
+       unlinkmany $myDIR/t- 20000
+       rm -f $myDIR/guard
+       # The OI file should become empty now
+
+       # Create new files, idle OI blocks should be reused.
+       createmany -o $myDIR/t- 2000
+       do_facet $SINGLEMDS sync
+       # Make sure journal flushed.
+       sleep 6
+       local blk2=$(do_facet $SINGLEMDS \
+                    "$DEBUGFS -c -R \\\"stat oi.16.${IDX}\\\" $MDT_DEV" |
+                    grep Blockcount | awk '{print $4}')
+
+       [ $blk1 == $blk2 ] || error "old blk1=$blk1, new blk2=$blk2, unmatched!"
+}
+run_test 228c "NOT shrink the last entry in OI index node to recycle idle leaf"
+
 #
 # tests that do cleanup/setup should be run at the end
 #
@@ -9144,7 +9910,7 @@ test_900() {
 }
 run_test 900 "umount should not race with any mgc requeue thread"
 
-complete $(basename $0) $SECONDS
+complete $SECONDS
 check_and_cleanup_lustre
 if [ "$I_MOUNTED" != "yes" ]; then
        lctl set_param debug="$OLDDEBUG" 2> /dev/null || true